﻿using System;
using System.Collections.Generic;
using Ozeki.VoIP;
using Voice_IVR.Model.InputInterpreter;

namespace Voice_IVR.Model.IVRMenuElements
{
    internal interface IIVRMenuElement : ICloneable
    {
        /// <summary>
        /// The submenus contain
        /// </summary>
        Dictionary<object, IIVRMenuElement> SubMenu { get; set; }

        /// <summary>
        /// The current input interpreter
        /// </summary>
        IInputInterpreter InputInterpreter { get; set; }

        /// <summary>
        /// Activation of the engine
        /// </summary>
        /// <param name="phoneCall"></param>
        void EngineExecute(IPhoneCall call);

        /// <summary>
        /// DeActivate of the engine
        /// </summary>
        void EngineStop();

        /// <summary>
        /// Add a IVRSubmenu
        /// </summary>
        /// <param name="manuId"></param>
        /// <param name="menuElement"></param>
        void AddSubMenuElement(object manuId, IIVRMenuElement menuElement);
    }
}